#! /usr/bin/python

import os
import sys
import string
import glob


#orig_res = [300, 200, 630]
orig_res = [600, 400, 630]

dest_format = 'silo_big/%s'

#geometry_file = 'thm-20070323-j13c.630x200x300.grid'
geometry_file = 'thm-20070323-j13c.%dx%dx%d.grid' % (orig_res[2],orig_res[1],orig_res[0])


def build_silo_from_blocks ( filename, dest ):
    filename = filename.rstrip('/')
    silo_filename = "%s.silo" % (filename)
    cmd = './ar2silo -o %s %s %s' % (silo_filename, geometry_file, filename) 
    print cmd
    os.system( cmd )

    cmd = 'mv %s %s' % (silo_filename, dest) 
    print cmd
    os.system( cmd )
    

def main(argv=sys.argv):

    if len(argv) < 2:
        print 'usage: ./all_ar2silo <set_blocks_dir_0> ... <set_blocks_dir_n>'
        return 1

    set_dirs = argv[1:]

    for set in set_dirs:
        set = set.rstrip('/') 
        time_steps = glob.glob( set + '/[!.]*/' )
        time_steps = sorted(time_steps)

        (_,_,set_name) = set.rpartition('/')
        dest = dest_format % (set_name)
        
        try:
            os.mkdir( dest, 0700 )
        except OSError:
            pass



        for step in time_steps:
            build_silo_from_blocks (step, dest)
    
    return 0

if __name__ == '__main__':
    sys.exit(main())

