#! /usr/bin/python

import os
import sys
import string
import glob


#orig_res = [630, 200, 300]
orig_res = [630, 400, 600]
dim_label = ['X', 'Y', 'Z']

#geometry_file = 'thm-20070323-j13c.630x200x300.grid'
geometry_file = 'thm-20070323-j13c.630x400x600.grid'

blocks_dir = 'blocks/'

destination = 'silo_ur/'

data_filename = 'data.bin'
grid_filename = 'points.grid'

def dump_points (path):
    file = open(path + grid_filename, 'w')
    print >> file, 'DATASET RECTILINEAR_GRID'
    print >> file, 'DIMENSIONS %d %d %d' % (orig_res[0],orig_res[1],orig_res[2])
    for i in range( len(orig_res) ):
        print >> file, '%s_COORDINATES %d int' % (dim_label[i], orig_res[i])
        for n in range(0, orig_res[i]):
            print >> file, '%d' % (n*2),
        print >> file, ''
    file.close()



def build_silo_for_orig ( filename ):

    # build block directory
    os.mkdir( blocks_dir )
    path = blocks_dir + "b1/"
    os.mkdir( path )
    os.system( 'cp %s %s%s' % (filename, path, data_filename) )
    dump_points( path )

    silo_filename = "%s.silo" % (filename)
    print './ar2silo -o %s %s %s' % (silo_filename, geometry_file, blocks_dir) 
    os.system( './ar2silo -v -o %s %s %s' 
                % (silo_filename, geometry_file, blocks_dir) ) 

    # clean up
    print 'mv %s %s' % (silo_filename, destination) 
    os.system( 'mv %s %s' % (silo_filename, destination) )
    print 'rm -r %s' % (blocks_dir) 
    os.system( 'rm -r %s' % (blocks_dir) )


def main(argv=sys.argv):
    path = argv[1]
    path.rstrip('/')

    if not os.access( destination, os.F_OK ):
        os.mkdir( destination )

    for file in glob.iglob( path + '/[!.]*' ):
        print file + ':'
        build_silo_for_orig( file )
    return 0

if __name__ == '__main__':
    sys.exit(main())

