#! /usr/bin/python

import os
import sys
import string
import glob


orig_res = [300, 200, 630]


fdl_contents = '''<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE FileDescriptor PUBLIC "-//SDB//DTD//ED" "fdl.dtd">
<FileDescriptor fileName= "%s"  fileType="binary" recordSize="4" byteOrder="little">
    <Bounds lower= "0"    upper= "%d"/>
    <Bounds lower= "0"    upper= "%d"/>
    <Bounds lower= "0"    upper= "%d"/>
    <Field fieldName= "temp"   fieldType= "float"/>
</FileDescriptor>
'''



def dump_fdl (filename):
    fdl_filename = filename + '.fdl'
    fdl_out = open(fdl_filename, 'w')
    fdl_out.write ( fdl_contents % 
                    (filename, orig_res[0]-1, orig_res[1]-1, orig_res[2]-1) )
    return fdl_filename



def build_big_from_orig ( filename ):
    fdl_filename = dump_fdl( filename )
    print 'java -jar scaleUp.jar %s' % ( fdl_filename  ) 
    os.system( 'java -jar scaleUp.jar %s' % ( fdl_filename ) )

def main(argv=sys.argv):
    
    global error_offset

    if len(argv) < 2:
        print 'usage: ./scale_all.py <data-dir>'
        return 1

    path = argv[1]

    path.rstrip('/')

    files = glob.glob( path + '/[!.]*' )
    files = sorted(files)
   
    for file in files:
        print file + ':'
        file = os.path.abspath(file)
        build_big_from_orig( file )
    
    
    return 0

if __name__ == '__main__':
    sys.exit(main())

# Test:
# build_silo_from_orig('data/thm-20070323-j13c.bin.000780.rr')

