#! /usr/bin/python

import sys
import re
import glob

d = []

# test for uniform decimation
for z in range(0,38):
    for y in range(0,25):
        for x in range(0,79):
            d.append( (x*8,y*8,z*8) )



domain = set(d)

def read_grid_file(filename):
    
    lower = [0,0,0]
    upper = [0,0,0]
    
    file = open(filename, 'r')
    file.readline()
    file.readline()
    for i in range(3):
        file.readline()
        coords = file.readline()
        match = re.match(r'^(\d+).*\s(\d+)\s$', coords)
        if match is None:
            match = re.match(r'^(\d+)\s$', coords)
            if match is None:
                print 'Match Error'
                sys.exit(1)
            else: 
                lower[i] = int( match.group(1) )
                upper[i] = lower[i]
        else:
            lower[i] = int( match.group(1) )
            upper[i] = int( match.group(2) )
    file.close()

    #print lower,
    #print upper

    for x in range(lower[0],upper[0]+1,8):
        for y in range(lower[1],upper[1]+1,8):
            for z in range(lower[2],upper[2]+1,8):
                try:
                    domain.remove( (x,y,z) )
                except KeyError:
                    pass

def main(argv=sys.argv):
    path = argv[1]
    path.rstrip('/')

    blocks = glob.glob( path + '/[!.]*' )

    for file in blocks:
        file.rstrip('/')
        #print file + ':'
       
        read_grid_file( file + '/points.grid' )

    if len(domain) == 0:
        print 'Domain coverage verified.' 
        return 0
    else:
        print 'Domain coverage not verified: MISSING BLOCK!'
        print domain
        return 1

if __name__ == '__main__':
    sys.exit(main())
