#!/usr/bin/python

import sys
import glob
import os
import time

##################################################


#result_dir_format = 'visit_timings/big/%s_%s'
#result_dir_format = 'visit_timings/630x200x300/%s_%s'
#result_dir_format = 'visit_timings/630x400x600/%s_%s'
result_dir_format = 'visit_timings/meshes/%s_%s'

visit_script_slice = '''import sys

OpenDatabase("%s")
AddPlot("Pseudocolor", "multivar")
AddOperator("Slice")
DrawPlots()

sys.exit()
'''

visit_script_slice_diag = '''import sys

OpenDatabase("%s")
AddPlot("Pseudocolor", "multivar")
AddOperator("Slice")

t = SliceAttributes()

t.axisType = 4
t.phi = 50

SetOperatorOptions(t)

DrawPlots()

sys.exit()
'''

visit_script_volume = '''import sys

OpenDatabase("%s")
AddPlot("Volume", "multivar")
DrawPlots()

sys.exit()
'''


def dump_visit_script (filename, visit_script_contents):
    print "dumping visit script..." 
    script = open ("visit.py", 'w')
    script.write( visit_script_contents % (filename) )
    script.close()



def main(argv=sys.argv):

    if len(argv) < 3:
        print 'usage: ./time_visit.py [slice|volume] <silo_dirs>'
        return 1

   
    script_contents = ''

    plot_type = argv[1]
    if plot_type == 'slice':
        script_contents = visit_script_slice
    elif plot_type == 'slice_diag':
        script_contents = visit_script_slice_diag
    elif plot_type == 'volume':
        script_contents = visit_script_volume
    else:
        print 'unknown plot type: %s' % (plot_type)
        return 1

    # set the display environment variable in case this is being run 
    # remotely
    os.putenv('DISPLAY', ':0')
    
    data_sets = argv[2:]
    
    home_dir = os.getcwd()

    for set in data_sets:
        path = set
        path = path.rstrip('/')
    
        (junk, sep, set_name) = path.rpartition('/')
        result_dir = result_dir_format % (plot_type, set_name)
        print plot_type, set_name

        print 'cp -r %s /local/tmp' % (set)
        os.system( 'cp -r %s /local/tmp' % (set) )

        try: 
            os.mkdir( result_dir, 0700 )
        except OSError:
            pass
    
        time.sleep(1)
        
        print 'cp %s/log.txt %s' % (path, result_dir) 
        os.system( 'cp %s/log.txt %s' % (path, result_dir) )
    
        if not os.path.isabs(path):
            # resolve full path
            path = os.path.realpath( path )
        else:
            os.path.normpath( path )
    
        silo_files = glob.glob( path + '/[!.]*.silo' )
    
        os.chdir( result_dir )
    
        for file in silo_files:
            print file + ':'
            (fullpath, sep, filename) = file.rpartition('/')
            (filename, sep, ext) = filename.rpartition('.')
            os.mkdir( filename, 0700 )
            os.chdir( filename )
    
            dump_visit_script( file, script_contents )
    
            time.sleep(1)
    
            os.system( 'umount /local/tmp' )
            
            time.sleep(1)
            
            os.system( 'mount /local/tmp' )
    
            time.sleep(1)
    
    
            os.system( 
               'visit -cli -timing -withhold-timing-output -s visit.py' 
            )
       
            os.chdir('..')

            time.sleep(5)
        
        os.chdir( home_dir )

        print 'rm -rf /local/tmp/%s' % (set_name)
        os.system( 'rm -rf /local/tmp/%s' % (set_name) )

    return 0

if __name__ == '__main__':
    sys.exit(main())

 
