/*
 * Comments by rdb: 02/09/12
 */

package ar;


import java.io.IOException;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * XML reader for AR specification; it is not integrated into Granite.
 * 
 * @author svohr
 */
public class ARDLReader {
    public static void main (String [] args) 
    {
        if (args.length < 1) {
            System.err.println("missing filename arg.");
            System.exit(1);
        }
        
        ARDataSource ar = new ARDataSource();            
        String filename = args[0];    
        
        try {
            buildARDataSource (ar,filename);
            ar.dump();
        }
        catch (IOException e) {
            System.err.println ("IO error!");
        }
        catch (SAXException s) {
            System.err.println ("SAX error!");
        }
        
        return;
    }
    
    static public void buildARDataSource (ARDataSource arDS, String xmlURI)
        throws IOException, SAXException 
    {

        // Create instances needed for parsing
        XMLReader reader = XMLReaderFactory.createXMLReader(  );
        ContentHandler ardlHandler = new ARDLHandler( arDS );

        // Register content handler
        reader.setContentHandler(ardlHandler);

        // Register error handler

        // Parse
        InputSource inputSource = new InputSource( xmlURI );
        reader.parse(inputSource);
    }
}
