/*
 * ARError.java interface; documentation by rdb 2/08/12
 * 
 * possible weakness: 
 *   1. except for the "typeString" method, there is no clear way of knowing
 *      what "kind" of error is being encapsulated. Maybe "typeString" is 
 *      enough, but the way it has been implemented in AEFloatError, is not
 *      adequate.
 *   2. What exactly does the method "noError" mean? From ARFloatError, it seems
 *      to mean "set the error to 0". This isn't so clear. I'd prefer a method
 *      like 
 *   3. Should there be an ifDefined method?
 *   4. How is value set? Must be outside the interface spec. Is that good? 
 *      It has the advantage that the interface doesn't have to deal with types;
 *      that is very good.
 */

package ar;

/**
 * Interface to represent error values
 * 
 * @author svohr
 */
public interface ARError 
{
    public boolean withinTolerance( ARError e );
    public void    noError();
    public String  valueString();
    public String  typeString();    
}
