/*
 * MRDLReader.java: comments by rdb 02/10/12
 */

package ar;

import java.io.IOException;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * XML reader for files describing MR data
 * 
 * @author svohr
 */
public class MRDLReader {
    public static void main (String [] args) {
        
        if (args.length < 1) {
            System.err.println("MRDLReader: missing filename arg.");
            System.exit(1);
        }
        
        MRHierarchy mr = new MRHierarchy ();
        String filename = args[0];    
        
        try {
            readMRDLfile (mr,filename);
        }
        catch (IOException e) {
            System.err.println ("MRDLReader: IO error!");
        }
        catch (SAXException s) {
            System.err.println ("MRDLReader: SAX error!");
        }
        
        return;
    }
    
    static public void readMRDLfile (MRHierarchy mr, 
            String xmlURI) throws IOException, SAXException 
    {

        // Create instances needed for parsing
        XMLReader reader = XMLReaderFactory.createXMLReader(  );
        ContentHandler mrdlHandler = new MRDLHandler(mr);

        // Register content handler
        reader.setContentHandler(mrdlHandler);

        // Register error handler

        // Parse
        InputSource inputSource = new InputSource(xmlURI);
        reader.parse(inputSource);
    }
}
