package data;

import java.util.ArrayList;

public class DataInfo {
	
	private String type;
	private int numRes;
	private int errRes;
	private int errTol;
	private int depth;
	private int height;
	private int width;
	private String outputFDLPrefix;
	private String byteOrder;
	private ArrayList<String> errorTypes;
	
	
	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}
	/**
	 * @param type the type to set
	 */
	public void setType(String type) {
		this.type = type;
	}
	/**
	 * @return the num_res
	 */
	public int getNumRes() {
		return numRes;
	}
	/**
	 * @param num_res the num_res to set
	 */
	public void setNumRes(int numRes) {
		this.numRes = numRes;
	}
	/**
	 * @return the err_res
	 */
	public int getErrRes() {
		return errRes;
	}
	/**
	 * @param err_res the err_res to set
	 */
	public void setErr_res(int errRes) {
		this.errRes = errRes;
	}
	/**
	 * @return the err_tol
	 */
	public int getErrTol() {
		return errTol;
	}
	/**
	 * @param err_tol the err_tol to set
	 */
	public void setErr_tol(int errTol) {
		this.errTol = errTol;
	}
	/**
	 * @return the depth
	 */
	public int getDepth() {
		return depth;
	}
	/**
	 * @param depth the depth to set
	 */
	public void setDepth(int depth) {
		this.depth = depth;
	}
	/**
	 * @return the height
	 */
	public int getHeight() {
		return height;
	}
	/**
	 * @param height the height to set
	 */
	public void setHeight(int height) {
		this.height = height;
	}
	/**
	 * @return the width
	 */
	public int getWidth() {
		return width;
	}
	/**
	 * @param width the width to set
	 */
	public void setWidth(int width) {
		this.width = width;
	}
	/**
	 * @return the outputFDLPrefix
	 */
	public String getOutputFDLPrefix() {
		return outputFDLPrefix;
	}
	/**
	 * @param outputFDLPrefix the outputFDLPrefix to set
	 */
	public void setOutputFDLPrefix(String outputFDLPrefix) {
		this.outputFDLPrefix = outputFDLPrefix;
	}
	/**
	 * @return the byteOrder
	 */
	public String getByteOrder() {
		return byteOrder;
	}
	/**
	 * @param byteOrder the byteOrder to set
	 */
	public void setByteOrder(String byteOrder) {
		this.byteOrder = byteOrder;
	}
	/**
	 * @return the errorTypes
	 */
	public ArrayList<String> getErrorTypes() {
		return errorTypes;
	}
	/**
	 * @param errorTypes the errorTypes to set
	 */
	public void setErrorTypes(ArrayList<String> errorTypes) {
		this.errorTypes = errorTypes;
	}
	
	/**
	 * @param type the errorType to add
	 */
	public void addErrorType(String type) {
		errorTypes.add(type);
	}
	
	/**
	 * @param type the errorType to remove
	 */
	public void removeErrorType(String type) {
		errorTypes.remove(type);
	}
	
	public void parseString(String parseString) {
		try{
			errorTypes = new ArrayList<String>();
			System.out.println(parseString);
			String[] params = parseString.split(" ");
			type = params[1];
			numRes = Integer.parseInt(params[2]);
			errRes = Integer.parseInt(params[3]);
			errTol = Integer.parseInt(params[4]);
			depth = Integer.parseInt(params[5]);
			height = Integer.parseInt(params[6]);
			width = Integer.parseInt(params[7]);
			outputFDLPrefix = params[8];
			byteOrder = params[9];
			if(!byteOrder.equalsIgnoreCase("little") && 
					!byteOrder.equalsIgnoreCase("big")) {
				System.err.println("byteOrder must be \"little\" or \"big\"");
				throw new Exception ("Invalid byteOrder");
			}
			for(int i = 10; i < params.length; i++) {
				String s = new String(params[i]).trim();
				addErrorType(s);
			}
			if(errorTypes.isEmpty()) {
				System.err.println("Must specify at least one error type");
				throw new Exception ("Must specify at least one error type");
			}
		}
		catch (Exception e) {
			System.err.println("Parameter string is in incorrect format.\n"
					+ "Format is: INPUT type num_res _err_res err_tol depth height" +
							" width output_fdl_prefix byteOrder error_types ("
					+ "space delimited)");
		}
	}

}
