package data;

import java.io.*;
import java.net.*;
import java.nio.ByteBuffer;
import java.nio.FloatBuffer;

public class DataSocket {
	
	private ServerSocket socket;
	private Socket connection = null;
	private PrintWriter out;
	private int port;
	private byte[] bytes;
	private DataInputStream dis;
	private int arraysize;
	
	
		
	public DataSocket(int port) {
		this.port = port;

	}
	
	public void setArraySize(int arraysize) {
		this.arraysize = arraysize;
	}
	
	float[] listen () {
		//The arraysize is in bytes - 4 bytes to a float
		float[] retVal = new float[arraysize/4];
		int pos = 0;
		try{
			
			int buffer = 32768;
			if(buffer > arraysize)
				buffer = arraysize;
			socket = new ServerSocket(port, 10);
			System.out.println("Waiting for connection");
			connection = socket.accept();
			System.out.println("Received connection ");
			out = new PrintWriter(connection.getOutputStream());
			dis = new DataInputStream(connection.getInputStream());
			bytes = new byte[arraysize];
			
			try{
				int len = 0;
				int curPos = 0;
				while((len = dis.read(bytes, curPos, buffer)) != -1 
						&& buffer != 0) {
					curPos += len;
					if(curPos + buffer > arraysize)
						buffer = arraysize - curPos;
					sendMessage("received");
				}
			}
			catch(IndexOutOfBoundsException e) {
				e.printStackTrace();
			}
			catch(Exception e){
				System.err.println("Data received in unknown format");
			}
			ByteBuffer bb = ByteBuffer.wrap(bytes);
			bb.rewind();
			FloatBuffer fb = bb.asFloatBuffer();
			
			while(fb.hasRemaining()) {
				retVal[pos] = fb.get();
				pos++;
			}
			
		}
		catch(Exception e){
			e.printStackTrace();
			System.out.println(pos);
		}
		finally{
			try{
				dis.close();
				out.close();
				socket.close();
			}
			catch(IOException ioException){
				ioException.printStackTrace();
			}
		}
		return retVal;
		
		
	}
	
	void sendMessage(String msg)
	{
		try{
			out.println(msg);
			out.flush();
			System.out.println("server>" + msg);
		}
		catch(Exception exception){
			exception.printStackTrace();
		}
	}	
}
