/*
 * This is used to test a C++ to Java process.  The C++ client code
 * will send data of various sizes (read from files) and the server
 * will then output it to other files
 * 
 */

package data;

import java.io.FileNotFoundException;

import ar.MultiMRHierarchy;
import edu.unh.sdb.datasource.FDLDescriptor;


public class SocketHandler {
	
	//Don't hardcore me eventually
	private static float[][] data = new float[1][];
	
	//Sets up all parameters in one command.
	//"INPUT type num_res err_res err_tol depth height width 
	//					output_fdl_prefix byteOrder error_types"
	private static final String ALL = "INPUT";
	
	private static int currentRes = 0;
	//num_res from INPUT will change this
	private static int maxRes = 1;
		
	public static void main(String[] args) {
		if(args.length < 2) {
			System.out.println("Usage: commandSocketPort dataSocketPort");
			System.exit(1);
		}
		
		final CommandSocket cs = new CommandSocket(Integer.parseInt(args[0]));
		final DataSocket ds = new DataSocket(Integer.parseInt(args[1]));
		
		final StringBuffer cmd = new StringBuffer();
		final DataInfo di = new DataInfo();
			
			//Command Socket Thread
			Thread t1 = new Thread() {
				public void run() {
					while(true) {
						String s = cs.listen();
						System.out.println("Command received: " + s);
						cmd.append(s);
						
					}
				}
			};
			
			//Data Socket Thread
			Thread t2 = new Thread() {
				public void run() {
					while(true) {
						if( cmd != null
								&& cmd.toString().startsWith(ALL) ) {
							di.parseString(cmd.toString());
							maxRes = di.getNumRes();
							cmd.setLength(0);
							ds.setArraySize( di.getHeight() * di.getWidth() * di.getHeight() * 4 );
							data[currentRes] = ds.listen();
							currentRes++;
							System.out.println("Data received");
						}
							
					}	
				}
			};
			t1.start();
			t2.start();
			
			while(currentRes < maxRes) {
					//Without this pause, there were some issues
					//with threading - this is not the best approach.
					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
			}
			
			//This signifies that we read all of the data						
			MultiMRHierarchy mr = new MultiMRHierarchy(data, di);
			currentRes = 0;
	}
	
}
	