/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package error;

import edu.unh.sdb.common.Datum;
import edu.unh.sdb.common.FloatDatum;
import edu.unh.sdb.common.RecordDescriptor;
import edu.unh.sdb.datasource.DataCollection;
import edu.unh.sdb.datasource.ISIterator;

/**
 *
 * @author svohr
 */
public class AvgAbsErrorFunction implements ErrorFunction {

    private String funcName;
    private RecordDescriptor rd;
    

    public AvgAbsErrorFunction ()
    {
        funcName = "avgabs";
        rd = new RecordDescriptor ('f', 1);
        
    }
    
    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed ) 
    {
        Datum result = new FloatDatum (1);
        
        return this.calculate(actual, reconstructed, result);
    }

    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed, Datum result ) 
    {
        
        float [] actualValues = actual.getFloats(0);
        float [] reconstructedValues = reconstructed.getFloats(0);
        
        float total = 0;
        float count = actualValues.length;
        
        for (int i=0; i< actualValues.length; i++ ) {
            total += Math.abs( actualValues[i] - reconstructedValues[i] );
        }

        result.setFloat(0, total / count);

        return result;
    }

    public String name() 
    {
        return this.funcName;
    }

    public RecordDescriptor getRecordDescriptor() 
    {
        return this.rd;
    }

}
