/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package error;

import edu.unh.sdb.datasource.FDLDescriptor;
import edu.unh.sdb.datasource.ISBounds;
import java.io.FileNotFoundException;
import java.nio.ByteOrder;

/**
 *
 * @author svohr
 */
public class LowResDataSetWriter extends DataSetWriter {

    private int resolution;
    

    /**
     * This constructor is used to pass in a file name instead of an 
     * FDLDescriptor in the case that data is coming from memory instead 
     * of from a file.
     * @param i
     * @param filePrefix
     * @param reducer
     * @param lowSize
     */
	public LowResDataSetWriter(int res, String filePrefix, ISBounds lowSize, 
		String byteOrder)
		throws FileNotFoundException 
	{
	            
      String name = filePrefix;

      name = name + ".d" + res;

      // Make a new fdl descriptor based on the original. 
      // All attributes show remain unchanged except for the bounds (size).
      this.fd = new FDLDescriptor();
      fd.setBounds(lowSize);
      fd.setDataFileURL(name);
      fd.setDataFileType("binary");
      if (byteOrder.equalsIgnoreCase("big"))
         fd.setByteOrder(ByteOrder.BIG_ENDIAN);
      else
         fd.setByteOrder(ByteOrder.LITTLE_ENDIAN);


      this.filename = name;

      this.openForWriting();
	
	}
	
    public LowResDataSetWriter ( int res, FDLDescriptor orig, ISBounds lowSize ) 
        throws FileNotFoundException
    {

        // Build a name for the new file.
        String name = new String (orig.getDataFileURL());
        
        //if ( name.matches("\\.rr$") ) {
        //    name = name.substring( 0, name.lastIndexOf(".rr") );
        //}
        
        name = name + ".d" + res;
        
        // Make a new fdl descriptor based on the original. 
        // All attributes show remain unchanged except for the bounds (size).
        this.fd = (FDLDescriptor)orig.clone();
        fd.setBounds( lowSize );
        fd.setDataFileURL( name );
        
        this.filename = name;
        
        this.openForWriting();

    }
}
