/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package error;

import edu.unh.sdb.common.AttributeDescriptor;
import edu.unh.sdb.common.Datum;
import edu.unh.sdb.common.FloatDatum;
import edu.unh.sdb.common.RecordDescriptor;
import edu.unh.sdb.common.StorageType;
import edu.unh.sdb.datasource.DataCollection;

/**
 *
 * @author svohr
 */
public class MaxAbsErrorFunction implements ErrorFunction {

    private String funcName;
    private RecordDescriptor rd;
    
    private Datum a;
    private Datum r;

    public MaxAbsErrorFunction ()
    {
        funcName = "maxabs";
        
        
        AttributeDescriptor [] alist = new AttributeDescriptor [1];
        alist[0] = new AttributeDescriptor (StorageType.Float, funcName);
        
        rd = new RecordDescriptor (alist);

        a = new FloatDatum (1);
        r = new FloatDatum (1);
    }
    
    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed ) 
    {
        Datum result = new FloatDatum (1);
        
        return this.calculate(actual, reconstructed, result);
    }

    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed, Datum result ) 
    {
        assert actual.getBounds().equalShape(reconstructed.getBounds());
        
        float [] actualValues = actual.getFloats(0);
        float [] reconstructedValues = reconstructed.getFloats(0);
        
        float max = 0;
        float diff = 0;
        
        for ( int i=0; i< actualValues.length; i++ )
        {
            assert actualValues[i] == actualValues[i];
            assert reconstructedValues[i] == reconstructedValues[i];

            diff = Math.abs( actualValues[i] - reconstructedValues[i] );
            
            if ( max < diff ) {
                max = diff;
            }
        }
        
        result.setFloat(0, max);
        
        return result;
    }

    public String name() 
    {
        return this.funcName;
    }

    public RecordDescriptor getRecordDescriptor() 
    {
        return this.rd;
    }

}
