/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package error;

import edu.unh.sdb.common.Datum;
import edu.unh.sdb.common.FloatDatum;
import edu.unh.sdb.common.RecordDescriptor;
import edu.unh.sdb.datasource.DataCollection;

/**
 *
 * @author svohr
 */
public class StdDevErrorFunction implements ErrorFunction {

    private String funcName;
    private RecordDescriptor rd;

    public StdDevErrorFunction ()
    {
        funcName = "stddev";
        rd = new RecordDescriptor ('f', 1);
    }
    
    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed ) 
    {
        Datum result = new FloatDatum (1);
        
        return this.calculate(actual, reconstructed, result);
    }

    public Datum calculate( DataCollection actual, 
                            DataCollection reconstructed, Datum result ) 
    {

        float [] actualValues = actual.getFloats(0);
        float [] reconstructedValues = reconstructed.getFloats(0);
       
        float total = 0.f;
        float mean;
        float count;
        
        int i;
        for ( i=0; i< actualValues.length; i++ ) {
          
            total += Math.abs( actualValues[i] - reconstructedValues[i] );
        }
        
        count = i + 1;

        mean = total / count;

        for ( i=0; i< actualValues.length; i++ ) {

            total += 
                (float) Math.pow ( 
                    Math.abs( actualValues[i] - reconstructedValues[i] ) - mean,
                    2.); 
        }
        
        result.setFloat(0, (float) Math.sqrt (total / count) );
        
        return result;
    }

    public String name() 
    {
        return this.funcName;
    }

    public RecordDescriptor getRecordDescriptor() 
    {
        return this.rd;
    }

}
