/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package error;

import edu.unh.sdb.datasource.ISBounds;

/**
 *
 * @author svohr
 */
public class WaveletCoords extends Coords {


    public int[] lowResToBase(int res, int[] point) 
    {
        int factor = 1 << (res + 1); // 2 ^ (res + 1), c style!
        int offset = (1 << res) - 1;
        for (int i=0; i<point.length; i++) {
            point[i] *= factor; // move it to base resolution.
            point[i] += offset; // shift it over
        }
        return point;
    
    }

    public int lowResToBase1d(int res, int p) 
    {
        int factor = 1 << (res + 1); // 2 ^ (res + 1), c style!
        int offset = (1 << res) - 1;
        return (p * factor) + offset;
    }

    public ISBounds baseToLowRes(int res, ISBounds b)
    {
        
        int [] lower = b.copyLowerArray();
        int [] upper = b.copyUpperArray();
        
        int factor = 1 << (res + 1);
        
        for ( int i=0; i<lower.length; i++ ) {
            
            int base = lower[i];
            
            lower[i] = base / factor;
            if ( base % factor != 0 )
                lower[i] += 1;
            
            upper[i] = upper[i] / factor;
            
            if (lower[i] > upper[i])
                return null;
        }
        
        return new ISBounds (lower, upper);
    }
    
}
