/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package selection;

import edu.unh.sdb.datasource.FDLDescriptor;
import edu.unh.sdb.datasource.ISBounds;
import java.io.FileNotFoundException;

/**
 *
 * @author svohr
 */
public class MaxAbsErrorWriter extends ErrorWriter {
    
    public MaxAbsErrorWriter (  String name, int dataLevel, int errorLevel,
                                int max, ISBounds size, FDLDescriptor base) 
            throws FileNotFoundException
    {
        super (name + "_maxabs", dataLevel, errorLevel, max, size, base);
    }
    
    /**
     * Calculates the maximum absolute error between an actual and 
     * reconstructed error cell.
     * 
     * @param actual actual error cell data
     * @param reconstructed reconstructed error cell data
     * 
     * @return maximum absolute error of the cell
     */
    public float calculate (float [][][] actual, float [][][] reconstructed) 
    {
        int regionSize = actual.length;
        float result = 0;
        
        // remember: the last row or column is not a part of the error cell.
        // hence length - 1.
        
     // System.err.println ("---------------------- " + cellSize + "^3");
        for ( int z=0; z < regionSize-1; z++ ) {
            for ( int y=0; y < regionSize-1; y++ ) {
                for ( int x=0; x < regionSize-1; x++ ) {
                    
                    float error = Math.abs( 
                            actual[z][y][x] - reconstructed [z][y][x] );
                                        
                    if (error > result) {
                        result = error;
                    }
                }
            }
        }
     // System.err.println ("----------------------");
        
//        System.err.println ("************************");
//            for (int i=0; i < regionSize; i++) {
//                for (int j=0; j < regionSize; j++) {
//                    for (int k=0; k < regionSize; k++) {
//                        System.err.print (
//                                Float.toString(actual[i][j][k]) + " " +
//                                Float.toString(reconstructed[i][j][k]) + " " );
//                    }
//                    System.err.println();
//                }
//            } 
//        System.err.println ("************************");
//        thing++;
//        System.err.println(result); 

        //System.err.println(result); 
        return result;
    }
    
}
