/*
 * A basic interface for reconstruction classes
 */

package selection;

import edu.unh.sdb.datasource.DataBlock;
import edu.unh.sdb.datasource.DataCollection;
import edu.unh.sdb.datasource.ISBounds;

/**
 * 
 * A basic interface for reconstruction classes
 * 
 * @author svohr
 */
public interface Reconstructor {
    
    /**
     * 
     * @param original the original error cell
     * @return the reconstructed error cell.
     */
    public float [][][] reconstruct (float [][][] original);

    public DataBlock reconstruct ( DataCollection inData, ISBounds base, 
                                   int resolution, ISBounds region, int attr );


}
