/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package selection;

import edu.unh.sdb.datasource.FDLDescriptor;
import edu.unh.sdb.datasource.ISBounds;
import java.io.FileNotFoundException;

/**
 *
 * @author svohr
 */
public class SignalToNoiseErrorWriter extends ErrorWriter {

    public SignalToNoiseErrorWriter (  String name, int dataLevel, int errorLevel,
                                int max, ISBounds size, FDLDescriptor base) 
            throws FileNotFoundException
    {
        super (name + "_snr", dataLevel, errorLevel, max, size, base);
    }
    
    private float rms (float [][][] errorRegion) 
    {
        
        int cellDim = errorRegion.length - 1;
        
        float sum = 0;
        float n = (float)Math.pow(cellDim, 3);
        
        for (int i=0; i < cellDim; i++) {
            for (int j=0; j < cellDim; j++) {
                for (int k=0; k < cellDim; k++) {
                    sum += Math.pow(errorRegion[i][j][k],2);
                }
            }
        }
        
        return (float)Math.sqrt( sum / n);
    }
    
    public float calculate (float [][][] actual, float [][][] reconstructed)
    {
        int cellDim = reconstructed.length - 1;
        float noiseSum = 0;
        float n = (float)Math.pow(cellDim, 3);
        
        
        for (int i=0; i < cellDim; i++) {
            for (int j=0; j < cellDim; j++) {
                for (int k=0; k < cellDim; k++) {
                    noiseSum += Math.pow
                                 (reconstructed[i][j][k] - actual[i][j][k], 2);
                }
            }
        }
                
        float ampSignal = rms(actual);
        float ampNoise =  (float)Math.sqrt(noiseSum / n);
        
        if (ampNoise < 0.001) {
            ampNoise = 0.001f;
        }

        return 20 * (float)Math.log10( ampSignal / ampNoise );
    }
    
}
